#include <mruby.h>
#include <mruby/proc.h>
#include <stdio.h>

struct RClass *mod_easy_io;

static mrb_value delay_ms( mrb_state *mrb, mrb_value self )
{
	mrb_int ms;
	mrb_get_args( mrb, "i", &ms );
	printf("\ndelay_ms( %d )", ms); 

	return self; 
}

static mrb_value digitalOut( mrb_state *mrb, mrb_value self )
{
	mrb_int pin, level;
	mrb_get_args( mrb, "ii", &pin, &level);
	printf("\ndigitalOut( %2d, %2d )", pin, level ); 

	return self; 
}

static mrb_value pinMode( mrb_state *mrb, mrb_value self )
{
	mrb_int pin, mode;
	char *str_mode;
	char *in = "INPUT";
	char *out= "OUTPUT";
	mrb_get_args( mrb, "ii", &pin, &mode);
	str_mode = ( mode == 0 ) ? in : out ;
	printf("\npinMode( %2d, %s )", pin, str_mode ); 

	return self; 
}

void init_easy_io( mrb_state *mrb )
{
	mod_easy_io = mrb_define_module( mrb, "EasyIo");
	mrb_define_method( mrb, mod_easy_io, "delay_ms", delay_ms, ARGS_REQ(1)); 
	mrb_define_method( mrb, mod_easy_io, "digitalOut", digitalOut, ARGS_REQ(2)); 
	mrb_define_method( mrb, mod_easy_io, "pinMode", pinMode, ARGS_REQ(2)); 

}

